Index: /palm/trunk/SOURCE/microphysics.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics.f90	(revision 1114)
+++ /palm/trunk/SOURCE/microphysics.f90	(revision 1115)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! microphyical tendencies are calculated in microphysics_control in an optimized
+! way; unrealistic values are prevented; bugfix in evaporation; some reformatting
 !
 ! Former revisions:
@@ -35,5 +36,5 @@
 ! 1065 2012-11-22 17:42:36Z hoffmann
 ! Sedimentation process implemented according to Stevens and Seifert (2008).
-! Turbulence effects on autoconversion and accretion added (Seifert, Nuijens 
+! Turbulence effects on autoconversion and accretion added (Seifert, Nuijens
 ! and Stevens, 2010).
 !
@@ -48,11 +49,15 @@
 
     PRIVATE
-    PUBLIC dsd_properties, autoconversion, accretion, selfcollection_breakup, &
-           evaporation_rain, sedimentation_cloud, sedimentation_rain
-
-    INTERFACE dsd_properties
-       MODULE PROCEDURE dsd_properties
-       MODULE PROCEDURE dsd_properties_ij
-    END INTERFACE dsd_properties
+    PUBLIC microphysics_control
+
+    INTERFACE microphysics_control
+       MODULE PROCEDURE microphysics_control
+       MODULE PROCEDURE microphysics_control_ij
+    END INTERFACE microphysics_control
+
+    INTERFACE adjust_cloud
+       MODULE PROCEDURE adjust_cloud
+       MODULE PROCEDURE adjust_cloud_ij
+    END INTERFACE adjust_cloud
 
     INTERFACE autoconversion
@@ -92,10 +97,10 @@
 ! Call for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE dsd_properties
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE indices
+    SUBROUTINE microphysics_control
+
+       USE arrays_3d
+       USE control_parameters
+       USE indices
+       USE statistics
 
        IMPLICIT NONE
@@ -106,5 +111,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -112,12 +117,10 @@
        ENDDO
 
-    END SUBROUTINE dsd_properties
-
-
-    SUBROUTINE autoconversion
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
+    END SUBROUTINE microphysics_control
+
+    SUBROUTINE adjust_cloud
+
+       USE arrays_3d
+       USE cloud_parameters
        USE indices
 
@@ -129,5 +132,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -135,12 +138,13 @@
        ENDDO
 
-    END SUBROUTINE autoconversion
-
-
-    SUBROUTINE accretion
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
+    END SUBROUTINE adjust_cloud
+
+
+    SUBROUTINE autoconversion
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
+       USE grid_variables
        USE indices
 
@@ -152,5 +156,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -158,12 +162,12 @@
        ENDDO
 
-    END SUBROUTINE accretion
-
-
-    SUBROUTINE selfcollection_breakup
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
+    END SUBROUTINE autoconversion
+
+
+    SUBROUTINE accretion
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
        USE indices
 
@@ -175,5 +179,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -181,12 +185,12 @@
        ENDDO
 
-    END SUBROUTINE selfcollection_breakup
-
-
-    SUBROUTINE evaporation_rain
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
+    END SUBROUTINE accretion
+
+
+    SUBROUTINE selfcollection_breakup
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
        USE indices
 
@@ -198,5 +202,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -204,12 +208,13 @@
        ENDDO
 
-    END SUBROUTINE evaporation_rain
-
-
-    SUBROUTINE sedimentation_cloud
+    END SUBROUTINE selfcollection_breakup
+
+
+    SUBROUTINE evaporation_rain
 
        USE arrays_3d
        USE cloud_parameters
        USE constants
+       USE control_parameters
        USE indices
 
@@ -221,5 +226,5 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -227,12 +232,13 @@
        ENDDO
 
-    END SUBROUTINE sedimentation_cloud
-
-
-    SUBROUTINE sedimentation_rain
+    END SUBROUTINE evaporation_rain
+
+
+    SUBROUTINE sedimentation_cloud
 
        USE arrays_3d
        USE cloud_parameters
        USE constants
+       USE control_parameters
        USE indices
 
@@ -244,5 +250,30 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_2d(j,i)+1, nzt
+             DO  k = nzb_s_inner(j,i)+1, nzt
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE sedimentation_cloud
+
+
+    SUBROUTINE sedimentation_rain
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE constants
+       USE control_parameters
+       USE indices
+       USE statistics
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+
+ 
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
 
              ENDDO
@@ -256,21 +287,72 @@
 ! Call for grid point i,j
 !------------------------------------------------------------------------------!
-    SUBROUTINE dsd_properties_ij( i, j )
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE indices
-       USE control_parameters
-       USE user
-   
-       IMPLICIT NONE
-
-       INTEGER ::  i, j, k
-
-       DO  k = nzb_2d(j,i)+1, nzt
+
+    SUBROUTINE microphysics_control_ij( i, j )
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
+       USE statistics
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j
+
+       dt_micro = dt_3d * weight_pres(intermediate_timestep_count)
+!
+!--    Adjust unrealistic values
+       IF ( precipitation )  CALL adjust_cloud( i,j ) 
+!
+!--    Use 1-d arrays
+       q_1d(:)  = q(:,j,i)
+       pt_1d(:) = pt(:,j,i)
+       qc_1d(:) = qc(:,j,i)
+       nc_1d(:) = nc_const
+       IF ( precipitation )  THEN
+          qr_1d(:) = qr(:,j,i)
+          nr_1d(:) = nr(:,j,i)
+       ENDIF
+!
+!--    Compute cloud physics
+       IF ( precipitation )  THEN
+          CALL autoconversion( i,j )
+          CALL accretion( i,j )
+          CALL selfcollection_breakup( i,j )
+          CALL evaporation_rain( i,j )
+          CALL sedimentation_rain( i,j )
+       ENDIF
+
+       IF ( drizzle )  CALL sedimentation_cloud( i,j )
+!
+!--    Derive tendencies
+       tend_q(:,j,i)  = ( q_1d(:) - q(:,j,i) ) / dt_micro
+       tend_pt(:,j,i) = ( pt_1d(:) - pt(:,j,i) ) / dt_micro
+       IF ( precipitation )  THEN
+          tend_qr(:,j,i) = ( qr_1d(:) - qr(:,j,i) ) / dt_micro
+          tend_nr(:,j,i) = ( nr_1d(:) - nr(:,j,i) ) / dt_micro
+       ENDIF
+
+    END SUBROUTINE microphysics_control_ij
+
+    SUBROUTINE adjust_cloud_ij( i, j )
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+!
+!--    Adjust number of raindrops to avoid nonlinear effects in 
+!--    sedimentation and evaporation of rain drops due to too small or
+!--    too big weights of rain drops (Stevens and Seifert, 2008).
+!--    The same procedure is applied to cloud droplets if they are determined
+!--    prognostically.  
+       DO  k = nzb_s_inner(j,i)+1, nzt
 
           IF ( qr(k,j,i) <= eps_sb )  THEN
              qr(k,j,i) = 0.0
+             nr(k,j,i) = 0.0
           ELSE
 !
@@ -283,21 +365,10 @@
                 nr(k,j,i) = qr(k,j,i) * hyrho(k) / xrmax
              ENDIF
-             xr(k) = hyrho(k) * qr(k,j,i) / nr(k,j,i)
-!
-!--          Weight averaged diameter of rain drops:
-             dr(k) = ( hyrho(k) * qr(k,j,i) / nr(k,j,i) *                     &
-                       dpirho_l )**( 1.0 / 3.0 )
-!
-!--          Shape parameter of gamma distribution (Milbrandt and Yau, 2005;
-!--          Stevens and Seifert, 2008):
-             mu_r(k) = 10.0 * ( 1.0 + TANH( 1.2E3 * ( dr(k) - 1.4E-3 ) ) )
-!
-!--          Slope parameter of gamma distribution (Seifert, 2008):
-             lambda_r(k) = ( ( mu_r(k) + 3.0 ) * ( mu_r(k) + 2.0 ) *          &
-                             ( mu_r(k) + 1.0 ) )**( 1.0 / 3.0 ) / dr(k)
+
           ENDIF
-       ENDDO
-
-    END SUBROUTINE dsd_properties_ij
+
+       ENDDO
+
+    END SUBROUTINE adjust_cloud_ij
 
 
@@ -306,26 +377,24 @@
        USE arrays_3d
        USE cloud_parameters
-       USE constants
-       USE indices
-       USE control_parameters
-       USE statistics
+       USE control_parameters
        USE grid_variables
-   
-       IMPLICIT NONE
-
-       INTEGER ::  i, j, k
-       REAL    ::  k_au, autocon, phi_au, tau_cloud, xc, nu_c, rc,   &
-                   l_mix, re_lambda, alpha_cc, r_cc, sigma_cc, epsilon
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  alpha_cc, autocon, epsilon, k_au, l_mix, nu_c, phi_au,      &
+                   r_cc, rc, re_lambda, selfcoll, sigma_cc, tau_cloud, xc                      
 
 
        k_au = k_cc / ( 20.0 * x0 )
 
-       DO  k = nzb_2d(j,i)+1, nzt
-
-          IF ( ql(k,j,i) > 0.0 )  THEN
+       DO  k = nzb_s_inner(j,i)+1, nzt
+
+          IF ( qc_1d(k) > eps_sb )  THEN
 !
 !--          Intern time scale of coagulation (Seifert and Beheng, 2006):
-!--          (1.0 - ql(k,j,i) / ( ql(k,j,i) + qr(k,j,i) ))
-             tau_cloud = 1.0 - ql(k,j,i) / ( ql(k,j,i) + qr(k,j,i) + 1.0E-20 )
+!--          (1.0 - qc(k,j,i) / ( qc(k,j,i) + qr_1d(k) ))
+             tau_cloud = 1.0 - qc_1d(k) / ( qr_1d(k) + qc_1d(k) )
 !
 !--          Universal function for autoconversion process 
@@ -335,8 +404,8 @@
 !--          Shape parameter of gamma distribution (Geoffroy et al., 2010):
 !--          (Use constant nu_c = 1.0 instead?)
-             nu_c      = 1.0 !MAX( 0.0, 1580.0 * hyrho(k) * ql(k,j,i) - 0.28 )
+             nu_c      = 1.0 !MAX( 0.0, 1580.0 * hyrho(k) * qc(k,j,i) - 0.28 )
 !
 !--          Mean weight of cloud droplets:
-             xc        = hyrho(k) * ql(k,j,i) / nc
+             xc = hyrho(k) * qc_1d(k) / nc_1d(k)
 !
 !--          Parameterized turbulence effects on autoconversion (Seifert, 
@@ -371,16 +440,13 @@
 !
 !--          Autoconversion rate (Seifert and Beheng, 2006):
-             autocon   = k_au * ( nu_c + 2.0 ) * ( nu_c + 4.0 ) /              &
-                         ( nu_c + 1.0 )**2 * ql(k,j,i)**2 * xc**2 *            &
-                         ( 1.0 + phi_au / ( 1.0 - tau_cloud )**2 ) *           &
-                         rho_surface
-             autocon   = MIN( autocon, ql(k,j,i) / ( dt_3d *                   &
-                              weight_substep(intermediate_timestep_count) ) )
-!
-!--          Tendencies for q, qr, nr, pt:
-             tend_qr(k,j,i) = tend_qr(k,j,i) + autocon
-             tend_q(k,j,i)  = tend_q(k,j,i)  - autocon
-             tend_nr(k,j,i) = tend_nr(k,j,i) + autocon / x0 * hyrho(k)
-             tend_pt(k,j,i) = tend_pt(k,j,i) + autocon * l_d_cp * pt_d_t(k)
+             autocon = k_au * ( nu_c + 2.0 ) * ( nu_c + 4.0 ) /    &
+                       ( nu_c + 1.0 )**2 * qc_1d(k)**2 * xc**2 *   &
+                       ( 1.0 + phi_au / ( 1.0 - tau_cloud )**2 ) * &
+                       rho_surface
+             autocon = MIN( autocon, qc_1d(k) / dt_micro )
+
+             qr_1d(k) = qr_1d(k) + autocon * dt_micro
+             qc_1d(k) = qc_1d(k) - autocon * dt_micro 
+             nr_1d(k) = nr_1d(k) + autocon / x0 * hyrho(k) * dt_micro
 
           ENDIF
@@ -395,20 +461,17 @@
        USE arrays_3d
        USE cloud_parameters
-       USE constants
-       USE indices
-       USE control_parameters
-       USE statistics
-       
-       IMPLICIT NONE
-
-       INTEGER ::  i, j, k
-       REAL    ::  accr, phi_ac, tau_cloud, k_cr
-
-       DO  k = nzb_2d(j,i)+1, nzt
-
-          IF ( ( ql(k,j,i) > 0.0 )  .AND.  ( qr(k,j,i) > eps_sb ) )  THEN
+       USE control_parameters
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  accr, k_cr, phi_ac, tau_cloud, xc
+
+       DO  k = nzb_s_inner(j,i)+1, nzt
+          IF ( ( qc_1d(k) > eps_sb )  .AND.  ( qr_1d(k) > eps_sb ) )  THEN
 !
 !--          Intern time scale of coagulation (Seifert and Beheng, 2006):
-             tau_cloud = 1.0 - ql(k,j,i) / ( ql(k,j,i) + qr(k,j,i) + 1.0E-20) 
+             tau_cloud = 1.0 - qc_1d(k) / ( qc_1d(k) + qr_1d(k) ) 
 !
 !--          Universal function for accretion process 
@@ -421,5 +484,5 @@
 !--          convert the dissipation (diss) from m2 s-3 to cm2 s-3.
              IF ( turbulence )  THEN
-                k_cr = k_cr0 * ( 1.0 + 0.05 *                            &
+                k_cr = k_cr0 * ( 1.0 + 0.05 *                             &
                                  MIN( 600.0, diss(k,j,i) * 1.0E4 )**0.25 )
              ELSE
@@ -428,13 +491,10 @@
 !
 !--          Accretion rate (Seifert and Beheng, 2006):
-             accr = k_cr * ql(k,j,i) * qr(k,j,i) * phi_ac *              &
+             accr = k_cr * qc_1d(k) * qr_1d(k) * phi_ac *                 &
                     SQRT( rho_surface * hyrho(k) )
-             accr = MIN( accr, ql(k,j,i) / ( dt_3d *                     &
-                    weight_substep(intermediate_timestep_count) ) )
-!
-!--          Tendencies for q, qr, pt:
-             tend_qr(k,j,i) = tend_qr(k,j,i) + accr
-             tend_q(k,j,i)  = tend_q(k,j,i)  - accr
-             tend_pt(k,j,i) = tend_pt(k,j,i) + accr * l_d_cp * pt_d_t(k) 
+             accr = MIN( accr, qc_1d(k) / dt_micro )
+
+             qr_1d(k) = qr_1d(k) + accr * dt_micro 
+             qc_1d(k) = qc_1d(k) - accr * dt_micro
 
           ENDIF
@@ -449,31 +509,25 @@
        USE arrays_3d
        USE cloud_parameters
-       USE constants
-       USE indices
-       USE control_parameters
-       USE statistics
+       USE control_parameters
+       USE indices
    
        IMPLICIT NONE
 
        INTEGER ::  i, j, k
-       REAL    ::  selfcoll, breakup, phi_br, phi_sc
-
-
-       DO  k = nzb_2d(j,i)+1, nzt
-
-          IF ( qr(k,j,i) > eps_sb )  THEN
-!
-!--          Selfcollection rate (Seifert and Beheng, 2006):
-!--          pirho_l**( 1.0 / 3.0 ) is necessary to convert [lambda_r] = m-1 to 
-!--          kg**( 1.0 / 3.0 ).
-             phi_sc = 1.0 !( 1.0 + kappa_rr / lambda_r(k) *                        &
-                      !pirho_l**( 1.0 / 3.0 ) )**( -9 )
-
-             selfcoll = k_rr * nr(k,j,i) * qr(k,j,i) * phi_sc *               &
+       REAL    ::  breakup, dr, phi_br, selfcoll
+
+       DO  k = nzb_s_inner(j,i)+1, nzt
+          IF ( qr_1d(k) > eps_sb )  THEN
+!
+!--          Selfcollection rate (Seifert and Beheng, 2001):
+             selfcoll = k_rr * nr_1d(k) * qr_1d(k) *         &
                         SQRT( hyrho(k) * rho_surface )
 !
+!--          Weight averaged diameter of rain drops:
+             dr = ( hyrho(k) * qr_1d(k) / nr_1d(k) * dpirho_l )**( 1.0 / 3.0 )
+!
 !--          Collisional breakup rate (Seifert, 2008):
-             IF ( dr(k) >= 0.3E-3 )  THEN
-                phi_br  = k_br * ( dr(k) - 1.1E-3 )
+             IF ( dr >= 0.3E-3 )  THEN
+                phi_br  = k_br * ( dr - 1.1E-3 )
                 breakup = selfcoll * ( phi_br + 1.0 )
              ELSE
@@ -481,12 +535,8 @@
              ENDIF
 
-             selfcoll =  MAX( breakup - selfcoll, -nr(k,j,i) / ( dt_3d *      &
-                              weight_substep(intermediate_timestep_count) ) )
-!
-!--          Tendency for nr:
-             tend_nr(k,j,i) = tend_nr(k,j,i) + selfcoll
+             selfcoll = MAX( breakup - selfcoll, -nr_1d(k) / dt_micro )
+             nr_1d(k) = nr_1d(k) + selfcoll * dt_micro
 
           ENDIF          
-
        ENDDO
 
@@ -502,21 +552,18 @@
        USE cloud_parameters
        USE constants
-       USE indices
-       USE control_parameters
-       USE statistics
-
-       IMPLICIT NONE
-
-       INTEGER ::  i, j, k
-       REAL    ::  evap, alpha, e_s, q_s, t_l, sat, temp, g_evap, f_vent, &
-                   mu_r_2, mu_r_5d2, nr_0
-
-
-       DO  k = nzb_2d(j,i)+1, nzt
-
-          IF ( qr(k,j,i) > eps_sb )  THEN
+       USE control_parameters
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  alpha, dr, e_s, evap, evap_nr, f_vent, g_evap, lambda_r, &
+                   mu_r, mu_r_2, mu_r_5d2, nr_0, q_s, sat, t_l, temp, xr
+
+       DO  k = nzb_s_inner(j,i)+1, nzt
+          IF ( qr_1d(k) > eps_sb )  THEN
 !
 !--          Actual liquid water temperature:
-             t_l = t_d_pt(k) * pt(k,j,i)
+             t_l = t_d_pt(k) * pt_1d(k)
 !
 !--          Saturation vapor pressure at t_l:
@@ -526,45 +573,58 @@
              q_s = 0.622 * e_s / ( hyp(k) - 0.378 * e_s )
              alpha = 0.622 * l_d_r * l_d_cp / ( t_l * t_l )
-             q_s = q_s * ( 1.0 + alpha * q(k,j,i) ) / ( 1.0 + alpha * q_s )
+             q_s = q_s * ( 1.0 + alpha * q_1d(k) ) / ( 1.0 + alpha * q_s )
 !
 !--          Supersaturation:
-             sat = MIN( 0.0, ( q(k,j,i) - ql(k,j,i) ) / q_s - 1.0 )
+             sat = MIN( 0.0, ( q_1d(k) - qr_1d(k) - qc_1d(k) ) / q_s - 1.0 )
 !
 !--          Actual temperature:
-             temp = t_l + l_d_cp * ql(k,j,i)
-!
-!--          
-             g_evap = ( l_v / ( r_v * temp ) - 1.0 ) * l_v /                  &
-                      ( thermal_conductivity_l * temp ) + rho_l * r_v * temp /&
-                      ( diff_coeff_l * e_s )
-             g_evap = 1.0 / g_evap
+             temp = t_l + l_d_cp * ( qc_1d(k) + qr_1d(k) )
+    
+             g_evap = 1.0 / ( ( l_v / ( r_v * temp ) - 1.0 ) * l_v /   &
+                      ( thermal_conductivity_l * temp ) + r_v * temp / &
+                      ( diff_coeff_l * e_s ) )
+!
+!--          Mean weight of rain drops
+             xr = hyrho(k) * qr_1d(k) / nr_1d(k)
+!
+!--          Weight averaged diameter of rain drops:
+             dr = ( xr * dpirho_l )**( 1.0 / 3.0 )
 !
 !--          Compute ventilation factor and intercept parameter 
 !--          (Seifert and Beheng, 2006; Seifert, 2008):
              IF ( ventilation_effect )  THEN
-                mu_r_2   = mu_r(k) + 2.0
-                mu_r_5d2 = mu_r(k) + 2.5 
+!
+!--             Shape parameter of gamma distribution (Milbrandt and Yau, 2005;
+!--             Stevens and Seifert, 2008):
+                mu_r = 10.0 * ( 1.0 + TANH( 1.2E3 * ( dr - 1.4E-3 ) ) )
+!
+!--             Slope parameter of gamma distribution (Seifert, 2008):
+                lambda_r = ( ( mu_r + 3.0 ) * ( mu_r + 2.0 ) *       &
+                             ( mu_r + 1.0 ) )**( 1.0 / 3.0 ) / dr
+
+                mu_r_2   = mu_r + 2.0
+                mu_r_5d2 = mu_r + 2.5 
                 f_vent = a_vent * gamm( mu_r_2 ) *                            &
-                         lambda_r(k)**( -mu_r_2 ) +                           &
+                         lambda_r**( -mu_r_2 ) +                              &
                          b_vent * schmidt_p_1d3 *                             &
                          SQRT( a_term / kin_vis_air ) * gamm( mu_r_5d2 ) *    &
-                         lambda_r(k)**( -mu_r_5d2 ) *                         &
+                         lambda_r**( -mu_r_5d2 ) *                            &
                          ( 1.0 - 0.5 * ( b_term / a_term ) *                  &
-                         ( lambda_r(k) /                                      &
-                         (       c_term + lambda_r(k) ) )**mu_r_5d2 -         &
+                         ( lambda_r /                                         &
+                         (       c_term + lambda_r ) )**mu_r_5d2 -            &
                                  0.125 * ( b_term / a_term )**2 *             &
-                         ( lambda_r(k) /                                      &
-                         ( 2.0 * c_term + lambda_r(k) ) )**mu_r_5d2 -         &
+                         ( lambda_r /                                         &
+                         ( 2.0 * c_term + lambda_r ) )**mu_r_5d2 -            &
                                  0.0625 * ( b_term / a_term )**3 *            &
-                         ( lambda_r(k) /                                      &
-                         ( 3.0 * c_term + lambda_r(k) ) )**mu_r_5d2 -         &
+                         ( lambda_r /                                         &
+                         ( 3.0 * c_term + lambda_r ) )**mu_r_5d2 -            &
                                  0.0390625 * ( b_term / a_term )**4 *         &
-                         ( lambda_r(k) /                                      &
-                         ( 4.0 * c_term + lambda_r(k) ) )**mu_r_5d2 )
-                nr_0   = nr(k,j,i) * lambda_r(k)**( mu_r(k) + 1.0 ) /         &
-                         gamm( mu_r(k) + 1.0 ) 
+                         ( lambda_r /                                         &
+                         ( 4.0 * c_term + lambda_r ) )**mu_r_5d2 )
+                nr_0   = nr_1d(k) * lambda_r**( mu_r + 1.0 ) /                &
+                         gamm( mu_r + 1.0 ) 
              ELSE
                 f_vent = 1.0
-                nr_0   = nr(k,j,i) * dr(k)
+                nr_0   = nr_1d(k) * dr
              ENDIF
 !
@@ -572,13 +632,11 @@
              evap = 2.0 * pi * nr_0 * g_evap * f_vent * sat /    &
                     hyrho(k)
-             evap = MAX( evap, -qr(k,j,i) / ( dt_3d *            &
-                         weight_substep(intermediate_timestep_count) ) )
-!
-!--          Tendencies for q, qr, nr, pt:
-             tend_qr(k,j,i) = tend_qr(k,j,i) + evap
-             tend_q(k,j,i)  = tend_q(k,j,i)  - evap
-             tend_nr(k,j,i) = tend_nr(k,j,i) + c_evap * evap / xr(k) * hyrho(k)
-             tend_pt(k,j,i) = tend_pt(k,j,i) + evap * l_d_cp * pt_d_t(k) 
-
+
+             evap    = MAX( evap, -qr_1d(k) / dt_micro )
+             evap_nr = MAX( c_evap * evap / xr * hyrho(k), &
+                            -nr_1d(k) / dt_micro )
+
+             qr_1d(k) = qr_1d(k) + evap * dt_micro
+             nr_1d(k) = nr_1d(k) + evap_nr * dt_micro
           ENDIF          
 
@@ -593,32 +651,39 @@
        USE cloud_parameters
        USE constants
-       USE indices
-       USE control_parameters
+       USE control_parameters
+       USE indices
        
        IMPLICIT NONE
 
        INTEGER ::  i, j, k
-       REAL    ::  sed_q_const, sigma_gc = 1.3, k_st = 1.2E8
+       REAL    ::  sed_qc_const
+
+       REAL, DIMENSION(nzb:nzt+1) :: sed_qc
 
 !
 !--    Sedimentation of cloud droplets (Heus et al., 2010):
-       sed_q_const = k_st * ( 3.0 / ( 4.0 * pi * rho_l ))**( 2.0 / 3.0 ) *    &
+       sed_qc_const = k_st * ( 3.0 / ( 4.0 * pi * rho_l ))**( 2.0 / 3.0 ) *   &
                      EXP( 5.0 * LOG( sigma_gc )**2 )
 
-       sed_q = 0.0
-
-       DO  k = nzb_2d(j,i)+1, nzt
-          IF ( ql(k,j,i) > 0.0 )  THEN
-             sed_q(k) = sed_q_const * nc**( -2.0 / 3.0 ) *                    &
-                        ( ql(k,j,i) * hyrho(k) )**( 5.0 / 3.0 )
+       sed_qc(nzt+1) = 0.0
+
+       DO  k = nzt, nzb_s_inner(j,i)+1, -1
+          IF ( qc_1d(k) > eps_sb )  THEN
+             sed_qc(k) = sed_qc_const * nc_1d(k)**( -2.0 / 3.0 ) * &
+                        ( qc_1d(k) * hyrho(k) )**( 5.0 / 3.0 )
+          ELSE
+             sed_qc(k) = 0.0
           ENDIF
-       ENDDO
-!
-!--    Tendency for q, pt:
-       DO  k = nzb_2d(j,i)+1, nzt
-          tend_q(k,j,i)  = tend_q(k,j,i) + ( sed_q(k+1) - sed_q(k) ) *        &
-                           ddzu(k+1) / hyrho(k) 
-          tend_pt(k,j,i) = tend_pt(k,j,i) - ( sed_q(k+1) - sed_q(k) ) *       &
-                           ddzu(k+1) / hyrho(k) * l_d_cp * pt_d_t(k) 
+
+          sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q_1d(k) /     &
+                                      dt_micro + sed_qc(k+1) )
+
+          q_1d(k)  = q_1d(k)  + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /  &
+                                hyrho(k) * dt_micro
+          qc_1d(k) = qc_1d(k) + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) / & 
+                                hyrho(k) * dt_micro
+          pt_1d(k) = pt_1d(k) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) / &
+                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
+
        ENDDO
 
@@ -631,6 +696,6 @@
        USE cloud_parameters
        USE constants
-       USE indices
-       USE control_parameters
+       USE control_parameters
+       USE indices
        USE statistics
        
@@ -638,25 +703,33 @@
 
        INTEGER ::  i, j, k, k_run
-       REAL    ::  c_run, d_max, d_mean, d_min, dt_sedi, flux, z_run
-
-       REAL, DIMENSION(nzb:nzt) :: c_nr, c_qr, nr_slope, qr_slope, w_nr, w_qr
-
+       REAL    ::  c_run, d_max, d_mean, d_min, dr, dt_sedi, flux, lambda_r,  &
+                   mu_r, z_run
+
+       REAL, DIMENSION(nzb:nzt+1) :: c_nr, c_qr, d_nr, d_qr, nr_slope,        &
+                                     qr_slope, sed_nr, sed_qr, w_nr, w_qr 
 !
 !--    Computation of sedimentation flux. Implementation according to Stevens
 !--    and Seifert (2008).
        IF ( intermediate_timestep_count == 1 )  prr(:,j,i) = 0.0
-
-       dt_sedi = dt_3d * weight_substep(intermediate_timestep_count)
-
-       w_nr = 0.0
-       w_qr = 0.0
 !
 !--    Compute velocities 
        DO  k = nzb_s_inner(j,i)+1, nzt
-          IF ( qr(k,j,i) > eps_sb )  THEN
+          IF ( qr_1d(k) > eps_sb )  THEN
+!
+!--          Weight averaged diameter of rain drops:
+             dr = ( hyrho(k) * qr_1d(k) / nr_1d(k) * dpirho_l )**( 1.0 / 3.0 )
+!
+!--          Shape parameter of gamma distribution (Milbrandt and Yau, 2005;
+!--          Stevens and Seifert, 2008):
+             mu_r = 10.0 * ( 1.0 + TANH( 1.2E3 * ( dr - 1.4E-3 ) ) )
+!
+!--          Slope parameter of gamma distribution (Seifert, 2008):
+             lambda_r = ( ( mu_r + 3.0 ) * ( mu_r + 2.0 ) *          &
+                        ( mu_r + 1.0 ) )**( 1.0 / 3.0 ) / dr
+
              w_nr(k) = MAX( 0.1, MIN( 20.0, a_term - b_term * ( 1.0 +          &
-                       c_term / lambda_r(k) )**( -1.0 * ( mu_r(k) + 1.0 ) ) ) )
+                       c_term / lambda_r )**( -1.0 * ( mu_r + 1.0 ) ) ) )
              w_qr(k) = MAX( 0.1, MIN( 20.0, a_term - b_term * ( 1.0 +          &
-                       c_term / lambda_r(k) )**( -1.0 * ( mu_r(k) + 4.0 ) ) ) )
+                       c_term / lambda_r )**( -1.0 * ( mu_r + 4.0 ) ) ) )
           ELSE
              w_nr(k) = 0.0
@@ -666,36 +739,31 @@
 !
 !--    Adjust boundary values
-       w_nr(nzb_2d(j,i)) = w_nr(nzb_2d(j,i)+1)
-       w_qr(nzb_2d(j,i)) = w_qr(nzb_2d(j,i)+1)
-       w_nr(nzt) = w_nr(nzt-1)
-       w_qr(nzt) = w_qr(nzt-1)
+       w_nr(nzb_s_inner(j,i)) = w_nr(nzb_s_inner(j,i)+1)
+       w_qr(nzb_s_inner(j,i)) = w_qr(nzb_s_inner(j,i)+1)
+       w_nr(nzt+1) = 0.0
+       w_qr(nzt+1) = 0.0
 !
 !--    Compute Courant number
-       DO  k = nzb_s_inner(j,i)+1, nzt-1
+       DO  k = nzb_s_inner(j,i)+1, nzt
           c_nr(k) = 0.25 * ( w_nr(k-1) + 2.0 * w_nr(k) + w_nr(k+1) ) * &
-                    dt_sedi * ddzu(k)
+                    dt_micro * ddzu(k)
           c_qr(k) = 0.25 * ( w_qr(k-1) + 2.0 * w_qr(k) + w_qr(k+1) ) * &
-                    dt_sedi * ddzu(k)
-       ENDDO
+                    dt_micro * ddzu(k)
+       ENDDO     
 !
 !--    Limit slopes with monotonized centered (MC) limiter (van Leer, 1977):
        IF ( limiter_sedimentation )  THEN
 
-          qr(nzb_s_inner(j,i),j,i) = 0.0
-          nr(nzb_s_inner(j,i),j,i) = 0.0
-          qr(nzt,j,i) = 0.0
-          nr(nzt,j,i) = 0.0
-
-          DO k = nzb_s_inner(j,i)+1, nzt-1
-             d_mean = 0.5 * ( qr(k+1,j,i) + qr(k-1,j,i) )
-             d_min  = qr(k,j,i) - MIN( qr(k+1,j,i), qr(k,j,i), qr(k-1,j,i) )
-             d_max  = MAX( qr(k+1,j,i), qr(k,j,i), qr(k-1,j,i) ) - qr(k,j,i)
+          DO k = nzb_s_inner(j,i)+1, nzt
+             d_mean = 0.5 * ( qr_1d(k+1) + qr_1d(k-1) )
+             d_min  = qr_1d(k) - MIN( qr_1d(k+1), qr_1d(k), qr_1d(k-1) )
+             d_max  = MAX( qr_1d(k+1), qr_1d(k), qr_1d(k-1) ) - qr_1d(k)
 
              qr_slope(k) = SIGN(1.0, d_mean) * MIN ( 2.0 * d_min, 2.0 * d_max, &
                                                      ABS( d_mean ) )
 
-             d_mean = 0.5 * ( nr(k+1,j,i) + nr(k-1,j,i) )
-             d_min  = nr(k,j,i) - MIN( nr(k+1,j,i), nr(k,j,i), nr(k-1,j,i) )
-             d_max  = MAX( nr(k+1,j,i), nr(k,j,i), nr(k-1,j,i) ) - nr(k,j,i)
+             d_mean = 0.5 * ( nr_1d(k+1) + nr_1d(k-1) )
+             d_min  = nr_1d(k) - MIN( nr_1d(k+1), nr_1d(k), nr_1d(k-1) )
+             d_max  = MAX( nr_1d(k+1), nr_1d(k), nr_1d(k-1) ) - nr_1d(k)
 
              nr_slope(k) = SIGN(1.0, d_mean) * MIN ( 2.0 * d_min, 2.0 * d_max, &
@@ -709,7 +777,10 @@
 
        ENDIF
+
+       sed_nr(nzt+1) = 0.0
+       sed_qr(nzt+1) = 0.0
 !
 !--    Compute sedimentation flux
-       DO  k = nzt-2, nzb_s_inner(j,i)+1, -1
+       DO  k = nzt, nzb_s_inner(j,i)+1, -1
 !
 !--       Sum up all rain drop number densities which contribute to the flux 
@@ -719,7 +790,7 @@
           k_run = k
           c_run = MIN( 1.0, c_nr(k) )
-          DO WHILE ( c_run > 0.0  .AND.  k_run <= nzt-1 )
+          DO WHILE ( c_run > 0.0  .AND.  k_run <= nzt )
              flux  = flux + hyrho(k_run) *                                    &
-                     ( nr(k_run,j,i) + nr_slope(k_run) * ( 1.0 - c_run ) *    &
+                     ( nr_1d(k_run) + nr_slope(k_run) * ( 1.0 - c_run ) *     &
                      0.5 ) * c_run * dzu(k_run)
              z_run = z_run + dzu(k_run)
@@ -731,9 +802,9 @@
 !--       available
           flux = MIN( flux,                                                   &
-                      hyrho(k) * dzu(k) * nr(k,j,i) + sed_nr(k+1) * dt_sedi )
-
-          sed_nr(k)      = flux / dt_sedi
-          tend_nr(k,j,i) = tend_nr(k,j,i) + ( sed_nr(k+1) - sed_nr(k) ) *     &
-                                            ddzu(k+1) / hyrho(k)
+                      hyrho(k) * dzu(k+1) * nr_1d(k) + sed_nr(k+1) * dt_micro )
+
+          sed_nr(k) = flux / dt_micro
+          nr_1d(k)  = nr_1d(k) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /    &
+                                 hyrho(k) * dt_micro
 !
 !--       Sum up all rain water content which contributes to the flux 
@@ -747,5 +818,5 @@
 
              flux  = flux + hyrho(k_run) *                                    &
-                     ( qr(k_run,j,i) + qr_slope(k_run) * ( 1.0 - c_run ) *    &
+                     ( qr_1d(k_run) + qr_slope(k_run) * ( 1.0 - c_run ) *    &
                      0.5 ) * c_run * dzu(k_run)
              z_run = z_run + dzu(k_run)
